/****************************************
**  Copyright  (C)  W.ch  1999-2009   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB 1.1 Host Examples for CH376   **
**  KC7.0@MCS-51                      **
**  Version: v1.0                     **
**  Author: tech14					  **
**  Time  : 2009/11/18                **
****************************************
*/
/* CH376HID豸̣,HID豸*/


#include <stdio.h>
#include <reg52.h>
#include <string.h>

#include "CH376INC.H"

#include "hid.h"

// ȡ豸
const	unsigned char code SetupGetDevDescr[] = { 0x80, 0x06, 0x00, 0x01, 0x00, 0x00, 0x12, 0x00 };
// ȡ
const	unsigned char code SetupGetCfgDescr[] = { 0x80, 0x06, 0x00, 0x02, 0x00, 0x00, 0x09, 0x00 };
// USBַ
const	unsigned char code SetupSetUsbAddr[] = { 0x00, 0x05, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00 };
// USB
//const	unsigned char code SetupSetUsbConfig[] = { 0x00, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
// SET IDLE 
const	unsigned char code SetupSetidle[]={0x21,0x0a,0x00,0x00,0x00,0x00,0x00,0x00};        
// ȡHID  
const	unsigned char code SetupGetHidDes[]={0x81,0x06,0x00,0x22,0x00,0x00,0x81,0x00};    
// SET REPORT 
const   unsigned char code SetupSetReport[]={0x21,0x09,0x00,0x02,0x00,0x00,0x01,0x00};     


//Ƭ߷ʽCH376
#define CH376_CMD_PORT  *(unsigned char volatile xdata *)0xBDF1
#define CH376_DAT_PORT  *(unsigned char volatile xdata *)0xBCF0

#define CH376_INT_WIRE   INT0       //CH376жţʡԣ

struct _Device_Atti{
  	UINT8 Device_connect;      //豸״̬ 1ӣ0Ͽ
  	UINT8 Device_compat;       //0:Ǹ豸,1ʾ豸  
  	UINT8 Cfg_value;           //豸ֵ
  struct _Device{ 
  	UINT8 Device_type;	       //豸 1:̣2:
  	UINT8 Device_inf;	       //豸ӿں ĬΪ0  ֧ӿ豸
  	UINT8 Device_endp;         //豸˵ַ ֧һ˵
  	UINT8 Device_size;         //豸˵С 
  	UINT16 Device_report_len;   //豸
	UINT8 tog;				   //˵ͬ־
  }Device[2];
}Device_Atti = { 0 };

UINT8 receive_mode = 0x00,send_mode = 0x00;
UINT8 data_buf[160];
UINT8 status;
bit   flag_config_2; //ڶλȡ־

//**********************************************
//*	NAME:    mDelay2uS( )									 
//*	FUCTION: ʱ2usӺ									 
//*	
//* 									 
//*	˵    ݵƬƵе									 
//**********************************************

void mDelay2uS( )
{
 UINT8 i;
 for(i=1;i!=0;i--);

}

//**********************************************
//*	NAME:    mDelay50mS( )									 
//*	FUCTION: ʱ50msӺ									 
//*	
//* 									 
//*	˵    ݵƬƵе									 
//**********************************************

void mDelay50mS( )
{
 UINT8 i,j;
 for(i=250;i!=0;i--)
   for(j=250;j!=0;j--);
}

void mDelaymS(UINT8 delay)
{	unsigned char i;
	do{	for(i=0;i!=250;i++){;}
		for(i=0;i!=250;i++){;}
		for(i=0;i!=150;i++){;}
	}while(--delay);
}


//**********************************************
//*	NAME:    CH376_WR_CMD_PORT( UINT8 cmd )									 
//*	FUCTION: дCH376Ӻ									 
//*	8λ
//* 									 
//*	˵ٶȽϿĵƬҪ1.5uSʱ									 
//**********************************************

void CH376_WR_CMD_PORT( UINT8 cmd )
{
  CH376_CMD_PORT = cmd;
//  mDelay2uS( );             //ڸٵƬҪ2usʱ
}


//**********************************************
//*	NAME:    CH376_WR_DAT_PORT( UINT8 dat )									 
//*	FUCTION: дCH376Ӻ									 
//*	8λ
//* 									 
//*	˵ٶȽϿĵƬҪ0.6uSʱ									 
//**********************************************

void CH376_WR_DAT_PORT( UINT8 dat )
{
 CH376_DAT_PORT = dat;

}

//**********************************************
//*	NAME:    CH376_RD_DAT_PORT( void )									 
//*	FUCTION: CH376Ӻ									 
//*	
//* 8λ									 
//*	˵ٶȽϿĵƬҪ0.6uSʱ									 
//**********************************************

UINT8 CH376_RD_DAT_PORT( void )
{
  return(CH376_DAT_PORT);
}


//**********************************************
//*	NAME:    StdioInit( void )									 
//*	FUCTION: Ƭڳʼڼ									 
//*	
//* 									 
//*	˵ ƬƵ24M ʹöʱ1 9600									 
//**********************************************

void StdioInit( void )
{
  SCON = 0x50;
  TMOD = 0x20;
  PCON = 0x80;
  TH1 = 0xf3;
  TR1 = 1;
  TI = 1;
}

//**********************************************
//*	NAME:    Set_USB_Mode( UINT8 mode )									 
//*	FUCTION: CH376Ĺģʽ 0x06 Ϊģʽ									 
//*	ģʽ
//* ״̬ TRUEɹFALSEʧ									 
//*	˵ CH376Ĺģʽ									 
//**********************************************

UINT8 Set_USB_Mode( UINT8 mode ) {  
	UINT8 i;
	CH376_WR_CMD_PORT( CMD_SET_USB_MODE );
	CH376_WR_DAT_PORT( mode );
	receive_mode=send_mode=0x00;  //˸λUSBͬ־ 
	for( i=0; i!=100; i++ ) {    //ȴģʽ,30uS 
		if ( CH376_RD_DAT_PORT()==CMD_RET_SUCCESS ) return( TRUE );  //ɹ 
	}
	return( FALSE );              //CH376,оƬͺŴߴڴڷʽ߲֧
}


//*****************************************************
//*	NAME:    set_freq(void)									 
//*	FUCTION: CH376Ľģʽ									 
//*	
//* 									 
//*	˵ ̵ȵ豸Ҫch376Ϊģʽ									 
//******************************************************

void set_freq(void)
{	
	CH376_WR_CMD_PORT(0x0b);    // лʹ375Bģʽ 
	CH376_WR_DAT_PORT(0x17);
	CH376_WR_DAT_PORT(0xd8);
}



//*****************************************************
//*	NAME:     RD_USB_DATA( UINT8 *buf )									 
//*	FUCTION:  CH376Ķ˵㻺ȡյ									 
//*	: ݻĵַ
//* ؽյݳ									 
//*	˵    CH376˵㻺жȡյ									 
//******************************************************

UINT8 RD_USB_DATA( UINT8 *buf ) {  
	UINT8 i, len;
	CH376_WR_CMD_PORT( CMD01_RD_USB_DATA0 ); 	         // CH37Xȡݿ 
	len=CH376_RD_DAT_PORT();                             // ݳ 
	for ( i=0; i!=len; i++ ) *buf++=CH376_RD_DAT_PORT();
	return( len );
}


//*****************************************************
//*	NAME:     WR_USB_DATA( UINT8 len, UINT8 *buf )									 
//*	FUCTION:  CH376Ķ˵㻺дݿ								 
//*	: Ҫдݿĳȣдݻĵַ
//* 									 
//*	˵    CH376˵㻺дҪ͵ݿ									 
//******************************************************

void WR_USB_DATA( UINT8 len, UINT8 *buf ) {  
	CH376_WR_CMD_PORT( CMD10_WR_HOST_DATA );     // CH376Ķ˵㻺д׼͵
	CH376_WR_DAT_PORT( len );                    // ݳ, lenܴ64
	while( len-- ) CH376_WR_DAT_PORT( *buf++ );
}


//*****************************************************
//*	NAME:     issue_token(UINT8 endptog, UINT8 endp_and_pid )								 
//*	FUCTION:  ִUSB								 
//*	: ͬ־˵ź
//* 									 
//*	˵    4λĿĶ˵, 4λPID									 
//******************************************************

void issue_token(UINT8 endptog, UINT8 endp_and_pid ) {  
	CH376_WR_CMD_PORT( CMD2H_ISSUE_TKN_X );
	CH376_WR_DAT_PORT( endptog );
	CH376_WR_DAT_PORT( endp_and_pid );
	mDelay2uS();  
}


//*****************************************************
//*	NAME:     wait_interrupt( )								 
//*	FUCTION:  ȴжϣһȡж״̬								 
//*	: 
//* ж״̬									 
//*	˵    CH376ж(INT#͵ƽ)   									 
//******************************************************

UINT8 wait_interrupt( ) {  
	while( CH376_INT_WIRE ); 
	CH376_WR_CMD_PORT( CMD_GET_STATUS ); 
	return( CH376_RD_DAT_PORT() );
}


//*****************************************************
//*	NAME:     Get_Dev_Descr( )								 
//*	FUCTION:  ȡ豸								 
//*	: 
//* ɹ1򷵻0									 
//*	˵    óù̼ģʽȡ豸   									 
//******************************************************

UINT8 Get_Dev_Descr( )
{	
    UINT8 descr_len;
	UINT8  *p=data_buf;
	send_mode=0x00;
	WR_USB_DATA(8,SetupGetDevDescr);

	issue_token(send_mode,( 0 << 4 ) | DEF_USB_PID_SETUP);status=wait_interrupt();
	printf("status1=%02x ",(unsigned short)status);
	if(status==USB_INT_SUCCESS)                                                      //SETUP׶βɹ
	{
		receive_mode=0x80;
	}
	else return(0);

	issue_token(receive_mode,( 0 << 4 ) | DEF_USB_PID_IN);status=wait_interrupt();
	printf("status2=%02x ",(unsigned short)status);
	if(status==USB_INT_SUCCESS)														//DATA׶βɹ
	{
		descr_len=data_buf[0]-RD_USB_DATA(data_buf);	
		while(descr_len>0)
		{	
			receive_mode ^= 0x80;
			p+=0x08;
			issue_token(receive_mode,( 0 << 4 ) | DEF_USB_PID_IN);status=wait_interrupt();
			if(status==USB_INT_SUCCESS)												//DATA׶βɹ
				descr_len-=RD_USB_DATA(p);	
			else return(0);
			
		}
	}
	else return(0);
	send_mode=0x40;
	WR_USB_DATA(0,SetupGetDevDescr);
	issue_token(send_mode,( 0 << 4 ) | DEF_USB_PID_OUT);status=wait_interrupt();
	printf("status3=%02x ",(unsigned short)status);
	if(status==USB_INT_SUCCESS)														//״̬׶βɹ
		return(1);	
	else return(0);
}



//*****************************************************
//*	NAME:     Get_Cfg_Descr( PUINT8 buf )								 
//*	FUCTION:  ȡ								 
//*	: ջַ
//* ɹ1򷵻0									 
//*	˵    óù̼ģʽȡ   									 
//******************************************************

UINT8 Get_Cfg_Descr( PUINT8 buf )
{
	unsigned char descr_len;
	unsigned char *p=data_buf;
	send_mode=0x00;
	WR_USB_DATA(8,buf);
	issue_token(send_mode,( 0 << 4 ) | DEF_USB_PID_SETUP);status=wait_interrupt();
	if(status==USB_INT_SUCCESS)														//SETUP׶βɹ
	{
		receive_mode=0x80;
	}
	else return(0);
	issue_token(receive_mode,( 0 << 4 ) | DEF_USB_PID_IN);status=wait_interrupt();
	if(status==USB_INT_SUCCESS)														//DATA׶βɹ
	{	
	    receive_mode ^= 0x80;
		if(flag_config_2)														    //ڶλȡ豸
	         descr_len=data_buf[2]-RD_USB_DATA(data_buf);
		else descr_len=data_buf[0]-RD_USB_DATA(data_buf);	
		while(descr_len>0)
		{	
			p+=0x08;
			issue_token(receive_mode,( 0 << 4 ) | DEF_USB_PID_IN);status=wait_interrupt();
			if(status==USB_INT_SUCCESS)												//DATA׶βɹ
			  {
			    receive_mode ^= 0x80;
				descr_len-=RD_USB_DATA(p);	
			   }
			else return(0);
			
		}
	}
	else return(0);
	send_mode = 0x40;
	WR_USB_DATA(0,SetupGetCfgDescr);
	issue_token(send_mode,( 0 << 4 ) | DEF_USB_PID_OUT);status=wait_interrupt();
	if(status==USB_INT_SUCCESS)														//״̬׶βɹ
		return(1);	
	else return(0);
}

//*****************************************************
//*	NAME:     parse_config_descr( )								 
//*	FUCTION:  򵥵ķеϢ								 
//*	: 
//* 									 
//*	˵    豸Ľӿں,˵ַ,,ָ֧豸   									 
//******************************************************

void parse_config_descr( )
{
  Device_Atti.Device_connect = 1;						                    //ʾ豸
  Device_Atti.Cfg_value = ((PUSB_CFG_DESCR)data_buf)->bConfigurationValue;  //еֵ

 if(((PUSB_CFG_DESCR)data_buf)->bNumInterfaces==1)		  					//ֻһӿ豸
  {
    Device_Atti.Device_compat = 0;						  					//Ǹ豸

 #define HID_Dev  ((PHID_DEVICE)data_buf)
    
  	Device_Atti.Device[0].Device_type =  HID_Dev->hid_itf_descr.bInterfaceProtocol;	//豸ͣ0x01 ̣0x02 
	Device_Atti.Device[0].Device_inf  =  HID_Dev->hid_itf_descr.bInterfaceNumber;	//豸Ľӿں
	Device_Atti.Device[0].Device_endp =  HID_Dev->endp_descr.bEndpointAddress;		//豸˵ַ
  	Device_Atti.Device[0].Device_size =  HID_Dev->endp_descr.wMaxPacketSize;		//豸˵С
	Device_Atti.Device[0].Device_report_len =  (HID_Dev->hid_class_descr.wDescriptorLength>>8)|(HID_Dev->hid_class_descr.wDescriptorLength<<8);	   //ȣСݸʽת
  
  }

 else if(((PUSB_CFG_DESCR)data_buf)->bNumInterfaces==2)		  				//2ӿ豸
  {
    Device_Atti.Device_compat = 1;						  					//豸

 #define HID_Dev1  ((PHID_COMPOSITE_DEVICE1)data_buf)
    
  	Device_Atti.Device[0].Device_type =  HID_Dev1->hid_itf_descr1.bInterfaceProtocol;
	Device_Atti.Device[0].Device_inf  =  HID_Dev1->hid_itf_descr1.bInterfaceNumber;
	Device_Atti.Device[0].Device_endp =  HID_Dev1->endp_descr1.bEndpointAddress;
  	Device_Atti.Device[0].Device_size =  HID_Dev1->endp_descr1.wMaxPacketSize;
	Device_Atti.Device[0].Device_report_len =  (HID_Dev1->hid_class_descr1.wDescriptorLength>>8)|(HID_Dev1->hid_class_descr1.wDescriptorLength<<8);	 //ȣСݸʽת
  
  	Device_Atti.Device[1].Device_type =  HID_Dev1->hid_itf_descr2.bInterfaceProtocol;
	Device_Atti.Device[1].Device_inf  =  HID_Dev1->hid_itf_descr2.bInterfaceNumber;
	Device_Atti.Device[1].Device_endp =  HID_Dev1->endp_descr2.bEndpointAddress;
  	Device_Atti.Device[1].Device_size =  HID_Dev1->endp_descr2.wMaxPacketSize;
	Device_Atti.Device[1].Device_report_len =  (HID_Dev1->hid_class_descr2.wDescriptorLength>>8)|(HID_Dev1->hid_class_descr2.wDescriptorLength<<8);	 //ȣСݸʽת

  }

}


//*****************************************************
//*	NAME:     set_config( UINT8 cfg )								 
//*	FUCTION:  USB豸								 
//*	: ֵ
//* ״̬ ɹ0x14									 
//*	˵    ֵȡ   									 
//******************************************************

UINT8 set_config( UINT8 cfg ) {  
	CH376_WR_CMD_PORT( CMD_SET_CONFIG );  
	CH376_WR_DAT_PORT( cfg );  
	return( wait_interrupt() );  
}

//*****************************************************
//*	NAME:     set_idle( UINT8 inf )								 
//*	FUCTION:  HID豸IDLE								 
//*	: ӿں
//* ״̬ ɹ1									 
//*	˵       									 
//******************************************************

UINT8 set_idle( UINT8 inf )
{
	send_mode=0x00;
	memcpy(data_buf,SetupSetidle,8);
	data_buf[4] = inf;
	WR_USB_DATA(8,data_buf);								//SETUP8ֽ
	issue_token(send_mode,( 0 << 4 ) | DEF_USB_PID_SETUP);
	status=wait_interrupt();
	if(status==USB_INT_SUCCESS)								//SETUP׶βɹ
	{
		receive_mode=0x80;
		issue_token(receive_mode,( 0 << 4 ) | DEF_USB_PID_IN );status=wait_interrupt();
		if(status==USB_INT_SUCCESS)							//״̬׶βɹ
		{
			if(RD_USB_DATA(data_buf)!=0)
			return(0);
		}
		else return(0);
	}
	else return(0);
	return(1);	
}


//*****************************************************
//*	NAME:     get_report_descr_ex( UINT8 inf,UINT16 len)								 
//*	FUCTION:  ȡHID豸ı								 
//*	: ӿںţ
//* ״̬ ɹ1									 
//*	˵    ȡHIDıȡHID   									 
//******************************************************

UINT8 get_report_descr_ex( UINT8 inf,UINT16 len)		
{
	unsigned char descr_len;
	unsigned char *p=data_buf;
	unsigned char report_cou_temp=0;
	send_mode=0x00;
	memcpy(data_buf,SetupGetHidDes,8);
	data_buf[4] = inf;
	data_buf[6] = len+0x40;
	descr_len = len;					
	WR_USB_DATA(8,data_buf);		
	issue_token(send_mode,( 0 << 4 ) | DEF_USB_PID_SETUP);status=wait_interrupt();	
	if(status==USB_INT_SUCCESS)														//SETUP׶βɹ
	{	
	    receive_mode=0x80;	
	}
	else return(0);
	issue_token(receive_mode,( 0 << 4 ) | DEF_USB_PID_IN);status=wait_interrupt();
	if(status==USB_INT_SUCCESS)														//DATA׶βɹ
	{	
	   
	   RD_USB_DATA( p );
		descr_len -= 0x08;													//ʣȼ
		while(descr_len>0)
		{	
			receive_mode ^= 0x80;
			p+=0x08;
			issue_token(receive_mode,( 0 << 4 ) | DEF_USB_PID_IN);status=wait_interrupt();
			if(status==USB_INT_SUCCESS)												// DATA׶βɹ
			{	
			    report_cou_temp=RD_USB_DATA(p);
				if(report_cou_temp!=0x08){ descr_len -= report_cou_temp; break;}
				else {descr_len-=0x08; }
			}
			else return(0);
			
		}
	}
	else return(0);
	send_mode=0x40;
	WR_USB_DATA(0,data_buf);
	issue_token(send_mode,( 0 << 4 ) | DEF_USB_PID_OUT);status=wait_interrupt();
	if(status==USB_INT_SUCCESS)														//״̬׶βɹ 
		return(1);	
	else return(0);
}


//*****************************************************
//*	NAME:     set_report( )								 
//*	FUCTION:  ڼ豸ñ								 
//*	: 
//* ״̬ ɹ1									 
//*	˵    ͨñָʾ   									 
//******************************************************

UINT8 set_report( )
{	
	send_mode=0x00;
	WR_USB_DATA(8,SetupSetReport);													//SETUP8ֽ
	issue_token(send_mode,( 0 << 4 ) | DEF_USB_PID_SETUP);status=wait_interrupt();
	if(status==USB_INT_SUCCESS)														//SETUP׶βɹ
	{	
	    send_mode ^= 0x40;
		data_buf[0]=0x01;
		WR_USB_DATA(1,data_buf);
		issue_token(send_mode,( 0 << 4 ) | DEF_USB_PID_OUT);status=wait_interrupt();
		if(status==USB_INT_SUCCESS) 												//DATA׶βɹ
		{	
		    receive_mode=0x80;
			issue_token(receive_mode,( 0 << 4 ) | DEF_USB_PID_IN);status=wait_interrupt();
			if(status==USB_INT_SUCCESS)												//״̬׶βɹ
			{	
			    if(RD_USB_DATA(data_buf)!=0)
				return(0);
			}
			else return(0);
		}
		else return(0);
	}	
	else return(0);
	
	
	return(1);
}


//*****************************************************
//*	NAME:     get_int_in(UINT8 tog,UINT8 endp_int)								 
//*	FUCTION:  ȡHID豸								 
//*	: 豸ͬ־˵
//* ״̬									 
//*	˵    ָ֧豸Ĳ  									 
//******************************************************

UINT8 get_int_in(UINT8 tog,UINT8 endp_int)
{
	UINT8 s,t,j;
	tog = tog ? 0x80 : 0x00;
	issue_token(tog,( endp_int << 4 ) | DEF_USB_PID_IN);
	s = wait_interrupt( );
	 if(s == USB_INT_SUCCESS)
	   {
		  t = RD_USB_DATA(data_buf);										//ж϶˵ݳһΪ8ֽڣΪ4ֽ
		
		for(j=0;j!=t;j++) printf("%02x ",(unsigned short)data_buf[j]);
  		if( endp_int == Device_Atti.Device[0].Device_endp )	
		 Device_Atti.Device[0].tog = Device_Atti.Device[0].tog ? FALSE : TRUE;
  	    else 
		 Device_Atti.Device[1].tog = Device_Atti.Device[1].tog ? FALSE : TRUE;
		}
	return s;
}


//*****************************************************
//*	NAME:     Reset_Device( )								 
//*	FUCTION:  λUSB豸ҽCH376óģʽ								 
//*	: 
//* 									 
//*	˵    USB淶δҪUSB豸븴λ豸
//*           ЩUSB豸ҲҪڲȸλܹ  									 
//******************************************************

void Reset_Device( )
{	
	Set_USB_Mode( 7 );  													//λUSB豸,CH376USBźߵD+D-͵ƽ
	mDelaymS(10);
	Set_USB_Mode( 6 );  													//λCH376óģʽ
	while ( wait_interrupt()!=USB_INT_CONNECT );  							//ȴλ֮豸ٴ

}

//*****************************************************
//*	NAME:     set_addr( UINT8 addr )								 
//*	FUCTION:  USB豸ַUSBҪUSB豸ַ								 
//*	: ֵַ(1~127)
//* ״̬									 
//*	˵    
//******************************************************

UINT8 set_addr( UINT8 addr ) { 
	UINT8 status;
	CH376_WR_CMD_PORT( CMD_SET_ADDRESS );  
	CH376_WR_DAT_PORT( addr );  
	status=wait_interrupt();  												//ȴCH376
	if ( status==USB_INT_SUCCESS ) {  										//ɹ
		CH376_WR_CMD_PORT( CMD_SET_USB_ADDR );  							//USB˵USBַ
		CH376_WR_DAT_PORT( addr );  										//ĿUSB豸ĵַɹ޸ĺ,Ӧͬ޸˵USBַ
	}
	return( status );
}



//**********************************************
//*	NAME:    main( void )									 
//*	FUCTION: ͨCH376ԼHID豸									 
//*	
//* 									 
//*	˵ֻͨUSḄָ֧豸
//*       ִ̣֧HUBӿڵUSB									 
//**********************************************

void main( void )
{
  UINT8 i,s;
  mDelay50mS( );	   //CH376ϵ֮Ҫʱ40ms
  
  StdioInit( );
  
  printf("start \n");

//ⵥƬCH376ӲӣԼдʱǷȷ  
  CH376_WR_CMD_PORT( 0x06 );

  CH376_WR_DAT_PORT( 0x55 );

  s = CH376_RD_DAT_PORT( );

  printf(" %02x \n",(UINT16)s);



  Set_USB_Mode( 6 );  									//USBģʽ, 豸CH37X, ô56

  set_freq( );	       									//ʹ376ģʽ
 
 while(1)
 {
    	
	printf(" \n wait usb device : \n");
	//mDelaymS(2000);
	while ( wait_interrupt()!=USB_INT_CONNECT ); 
	mDelaymS(50);
	Reset_Device();										//λusb豸
	mDelaymS(50);
    set_freq( );       									//ʹ376ģʽ
	mDelaymS(20);

//ȡ豸
	if(Get_Dev_Descr()==1)
	{
		for(i=0;i!=data_buf[0];i++)
		printf("%02x ",(unsigned int)data_buf[i]);	
		printf("\n");
	}
	else printf("\n get device descr failed \n");

//õַ		
	set_addr(5);										

//ȡ
	if( Get_Cfg_Descr( SetupGetCfgDescr ) == 1)
	 {
   		for(i=0;i!=data_buf[0];i++)
		printf("%02x ",(unsigned int)data_buf[i]);	
		printf("\n");
	 }
	 s = ((PUSB_CFG_DESCR)data_buf)->wTotalLengthL;
	 memcpy( data_buf,SetupGetCfgDescr,8);
     data_buf[6] = s;

	 flag_config_2 = 1;
	if( Get_Cfg_Descr( data_buf ) == 1)
	 {
   		for(i=0;i!=((PUSB_CFG_DESCR)data_buf)->wTotalLengthL;i++)
		printf("%02x ",(unsigned int)data_buf[i]);	
		printf("\n");
	 }
	flag_config_2 = 0;
//豸Ϣ
	parse_config_descr( );


//USB   
   s = set_config( Device_Atti.Cfg_value );
   printf(" cfg %02x \n",(UINT16)s);

//HID豸IDLE
   s = set_idle( Device_Atti.Device[0].Device_inf );
   if(s == 1) 
    printf("\n set idle success \n");
   else printf("\n set idle error \n");

//ȡHID豸ı
   s = get_report_descr_ex( Device_Atti.Device[0].Device_inf,Device_Atti.Device[0].Device_report_len);
	if( s == 1)
	 {
	   for(i=0;i!=Device_Atti.Device[0].Device_report_len;i++)
	    printf(" %02x ",(UINT16)data_buf[i]);
	 
	 }
	else printf(" report error %02x \n",(UINT16)s);
//HID豸Ǽ̣ñ
	if(Device_Atti.Device[0].Device_type == 0x01)
	{
	s = set_report( );
	if(s==1) printf("\n set report success \n");
	else printf("\n set report error \n");
	}

//豸Ǹ豸Ҫһӿ豸
#if 1
	if(Device_Atti.Device_compat == 1)
	{
//IDLE
	 s = set_idle( Device_Atti.Device[1].Device_inf );
      if(s == 1) 
   	  printf("\n set idle success \n");
     else printf("\n set idle error %02x \n",(UINT16)s);

//ȡ
     s = get_report_descr_ex( Device_Atti.Device[1].Device_inf,Device_Atti.Device[1].Device_report_len);
	  if( s == 1)
	   {
	    for(i=0;i!=Device_Atti.Device[1].Device_report_len;i++)
	    printf(" %02x ",(UINT16)data_buf[i]);	 
	   }

//豸Ǽ̣ñ
	if(Device_Atti.Device[1].Device_type == 0x01)
	 {
	  s = set_report( );
	  if(s==1) printf("\n set report success \n");
	  else printf("\n set report error \n");
 
 	 }
 
   }
#endif


 	CH376_WR_CMD_PORT( CMD20_SET_RETRY );		 //CH376Դ
	CH376_WR_DAT_PORT( 0x25 );
	CH376_WR_DAT_PORT( 0x00 );					 //Ϊ˱֤ԶڲҪ޴(0xc0),ڸ豸
	                                             //USBתPS2豸ϼ̣Ҫ(0x00)


	Device_Atti.Device[0].tog = FALSE;			 //豸ͬ־Ĭ0
 	Device_Atti.Device[1].tog = FALSE;
   while(1)
   {
//ȡ豸1
   	s = get_int_in( Device_Atti.Device[0].tog,Device_Atti.Device[0].Device_endp);

//豸Ƿ豸Ҫȡ豸2
	if( Device_Atti.Device_compat )
	{
	 s = get_int_in( Device_Atti.Device[1].tog,Device_Atti.Device[1].Device_endp);
	}

//Ǽ豸״̬
	CH376_WR_CMD_PORT(CMD01_TEST_CONNECT );			//豸
	 s = CH376_RD_DAT_PORT( );
	 if(s == USB_INT_DISCONNECT )
	 {
      Device_Atti.Device_connect = 0;
//	  Device_Atti = {0};
	  break;										//豸Ͽ
   	 }
   }
 }

}